namespace ServiceCenter.Controllers
{
    #region Using
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;

    using Data = ServiceCenter.Data.CastleActiveRecord;
    #endregion

    public class PositionController : Controller
    {
        #region Список
        public ActionResult Index()
        {
            ViewBag.Title = "Должности";

            List<Data.Position> positions = Data.Position.FindAll().OrderBy(x => x.Value).ToList();

            return View(positions);
        }
        #endregion

        #region Создание
        public ActionResult Create()
        {
            ViewBag.Title = "Должности - добавление записи";

            return View();
        }

        [HttpPost]
        public ActionResult Create(Data.Position position)
        {
            ViewBag.Title = "Должности - добавление записи";

            if (Data.Position.FindAll(position.Value) != null)
                ModelState.AddModelError("Value", string.Format("Должность '{0}' уже есть!", position.Value));

            if (!ModelState.IsValid)
                return View(position);

            try
            {
                position.Create();
                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", string.Format("При создании записи возникла ошибка:{0}{1}", Environment.NewLine, ex.Message));
                return View(position);
            }
        }
        #endregion

        #region Редактирование
        public ActionResult Edit(int id)
        {
            ViewBag.Title = "Должности - редактирование записи";

            Data.Position position = Data.Position.Find(id);

            ViewBag.Message = position.Value;

            return View(position);
        }

        [HttpPost]
        public ActionResult Edit(Data.Position position)
        {
            ViewBag.Title = "Должности - редактирование записи";
            ViewBag.Message = position.Value;

            if (Data.Position.FindAll(position.Value).FirstOrDefault(x => x.Id != position.Id) != null)
                ModelState.AddModelError("", string.Format("Должность '{0}' уже есть!", position.Value));

            if (!ModelState.IsValid)
                return View(position);

            try
            {
                position.Save();
                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", string.Format("При редактировании записи возникла ошибка:{0}{1}", Environment.NewLine, ex.Message));
                return View(position);
            }
        }
        #endregion

        #region Удаление
        public ActionResult Delete(int id)
        {
            Data.Position position = Data.Position.Find(id);

            position.Delete();

            return RedirectToAction("Index");
        }
        #endregion

        #region DropDown
        public ActionResult GetPositionDropDown(int selectedId)
        {
            ViewData.Model = Data.Position.FindAll().OrderBy(x => x.Value).Select(x => new SelectListItem()
            {
                Text = x.Value,
                Value = x.Id.ToString(),
                Selected = x.Id == selectedId
            });

            ViewData.ModelMetadata = new ModelMetadata(ModelMetadataProviders.Current, null, null, typeof(int), "PositionId")
            {
                NullDisplayText = "выберите должность"
            };

            return View("DropDown");
        }
        #endregion
    }
}
